aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorKonstantin Boudnik <cos@boudnik.org>2016-03-02 09:35:28 -0800
committerKonstantin Boudnik <cos@apache.org>2016-03-03 10:14:03 -0800
commit50783d7ceb54ff9afab4bff3df7ccde74b109e44 (patch)
treef74bfd99db948342f9288c60f0e8f1f181160b65
parent8f0645d1138ae39f1ebe08d8653ce8c577a9cc25 (diff)
BIGTOP-2352. Packaged Vagrant box has incorrect host info on restart
-rwxr-xr-xbigtop-deploy/vm/vagrant-puppet-vm/Vagrantfile4
-rwxr-xr-xbigtop-deploy/vm/vagrant-puppet-vm/config_hosts46
-rwxr-xr-xbigtop-deploy/vm/vagrant-puppet-vm/gen_hosts.sh44
3 files changed, 94 insertions, 0 deletions
diff --git a/bigtop-deploy/vm/vagrant-puppet-vm/Vagrantfile b/bigtop-deploy/vm/vagrant-puppet-vm/Vagrantfile
index ad13f5de..63aff201 100755
--- a/bigtop-deploy/vm/vagrant-puppet-vm/Vagrantfile
+++ b/bigtop-deploy/vm/vagrant-puppet-vm/Vagrantfile
@@ -72,6 +72,10 @@ chkconfig iptables off
# which miss leads some daemons to bind on 127.0.0.1 instead of public or private IP
sed -i "/127.0.0.1/d" /etc/hosts
echo "Bigtop yum repo = #{repo}"
+# Prepare host manipulation files needed in standalone box
+cp /bigtop-home/bigtop-deploy/vm/vagrant-puppet-vm/config_hosts /etc/init.d
+cp /bigtop-home/bigtop-deploy/vm/vagrant-puppet-vm/gen_hosts.sh /usr/bin
+chkconfig --add config_hosts
# Prepare puppet configuration file
mkdir -p /etc/puppet/hieradata
cp /bigtop-home/bigtop-deploy/puppet/hiera.yaml /etc/puppet
diff --git a/bigtop-deploy/vm/vagrant-puppet-vm/config_hosts b/bigtop-deploy/vm/vagrant-puppet-vm/config_hosts
new file mode 100755
index 00000000..c584a78c
--- /dev/null
+++ b/bigtop-deploy/vm/vagrant-puppet-vm/config_hosts
@@ -0,0 +1,46 @@
+#!/bin/bash
+
+# Hosts reconfiguration script
+# chkconfig: 345 70 1
+# description: config_hosts
+
+# Licensed to Hortonworks, Inc. under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. Hortonworks, Inc. licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+NAME="config_hosts"
+LOG="/var/log/config_hosts.log"
+
+source /etc/rc.d/init.d/functions
+
+case "$1" in
+start)
+ printf "%-50s\n" "Starting $NAME..." | tee -a $LOG
+
+ printf "%-50s\n" "Updating IP..." | tee -a $LOG
+ bash /usr/bin/gen_hosts.sh
+
+;;
+stop)
+ date >> $LOG
+;;
+
+restart)
+;;
+
+*)
+ echo "Usage: $0 {start|stop|restart}"
+ exit 1
+esac
diff --git a/bigtop-deploy/vm/vagrant-puppet-vm/gen_hosts.sh b/bigtop-deploy/vm/vagrant-puppet-vm/gen_hosts.sh
new file mode 100755
index 00000000..c629c85a
--- /dev/null
+++ b/bigtop-deploy/vm/vagrant-puppet-vm/gen_hosts.sh
@@ -0,0 +1,44 @@
+# Licensed to Hortonworks, Inc. under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. Hortonworks, Inc. licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+echo "# Do not remove the following line, or various programs" > /etc/hosts
+echo "# that require network functionality will fail." >> /etc/hosts
+echo "127.0.0.1 localhost.localdomain localhost" >> /etc/hosts
+
+function get_inet_iface(){
+ route | grep default | awk '{print $8}'
+}
+
+function get_ip() {
+ ip addr | grep 'inet ' | grep -E "($(get_inet_iface))" | awk '{ print $2 }' | awk -F'/' '{print $1}'
+}
+
+HOST=$(get_ip)
+NUM=5
+while [ -z "$HOST" ]; do
+ HOST=$(get_ip)
+ sleep 5
+ NUM=$(($NUM-1))
+ if [ $NUM -le 0 ]; then
+ HOST="127.0.0.1"
+ echo "Failed to update IP"
+ break
+ fi
+done
+echo "$HOST `hostname`" >> /etc/hosts
+
+echo 0 > /proc/sys/kernel/hung_task_timeout_secs
+ethtool -K $(get_inet_iface) tso off